DIRNAME(3)

NAME
dirname - extract the directory portion of a pathname

SYNOPSIS
#include <libgen.h>
char *
dirname(const char *path);

DESCRIPTION
The dirname() function is the converse of basename(3); it returns a pointer to the parent directory of the pathname pointed to by path. Any trailing ‘/’ characters are not counted as part of the directory name. If path is a null pointer, the empty string, or contains no ‘/’ characters, dirname() returns a pointer to the string ""., signifying the current directory.

RETURN VALUES
On successful completion, dirname() returns a pointer to the parent directory of path.

If dirname() fails, a null pointer is returned and the global variable errno is set to indicate the error.

ERRORS
The following error codes may be set in errno:

[ENAMETOOLONG]
    The path component to be returned was larger than PATH_MAX.

SEE ALSO
basename(1), dirname(1), basename(3)

STANDARDS
The dirname() function conforms to the X/Open System Interfaces option of the p1003.1-2008 specification.

HISTORY
The dirname() function first appeared in OpenBSD 2.2.

AUTHORS
Todd C. Miller

CAVEATS
dirname() returns a pointer to internal static storage space that will be overwritten by subsequent calls.

Other vendor implementations of dirname() may modify the contents of the string passed to dirname(); this should be taken into account when writing code which calls this function if portability is desired.